_bodhi-cli() {
    local i cur prev opts cmd
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="bodhi__cli"
                ;;
            bodhi__cli,comment)
                cmd="bodhi__cli__comment"
                ;;
            bodhi__cli,compose-info)
                cmd="bodhi__cli__compose__info"
                ;;
            bodhi__cli,compose-list)
                cmd="bodhi__cli__compose__list"
                ;;
            bodhi__cli,create-override)
                cmd="bodhi__cli__create__override"
                ;;
            bodhi__cli,create-update)
                cmd="bodhi__cli__create__update"
                ;;
            bodhi__cli,create-update-override)
                cmd="bodhi__cli__create__update__override"
                ;;
            bodhi__cli,edit-override)
                cmd="bodhi__cli__edit__override"
                ;;
            bodhi__cli,edit-update)
                cmd="bodhi__cli__edit__update"
                ;;
            bodhi__cli,expire-override)
                cmd="bodhi__cli__expire__override"
                ;;
            bodhi__cli,query-overrides)
                cmd="bodhi__cli__query__overrides"
                ;;
            bodhi__cli,query-updates)
                cmd="bodhi__cli__query__updates"
                ;;
            bodhi__cli,release-info)
                cmd="bodhi__cli__release__info"
                ;;
            bodhi__cli,release-list)
                cmd="bodhi__cli__release__list"
                ;;
            bodhi__cli,update-request)
                cmd="bodhi__cli__update__request"
                ;;
            bodhi__cli,waive-tests)
                cmd="bodhi__cli__waive__tests"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        bodhi__cli)
            opts="-n -k -v -h --staging --bodhi-url --login-url --no-store-password --ignore-keyring --verbose --help comment compose-info compose-list create-override create-update-override create-update edit-override edit-update expire-override query-overrides query-updates release-info release-list update-request waive-tests"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --bodhi-url)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --login-url)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__comment)
            opts="-h --update --text --karma --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --update)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --text)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --karma)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__compose__info)
            opts="-h --format --help <RELEASE> <REQUEST>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --format)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__compose__list)
            opts="-h --format --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --format)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__create__override)
            opts="-h --duration --notes --help <NVR>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --duration)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --notes)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__create__update)
            opts="-h --autokarma --autotime --bugs --builds --close-bugs --display-name --from-tag --notes --require-bugs --require-testcases --requirements --severity --stable-days --stable-karma --suggestion --unstable-karma --update-type --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --autokarma)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --autotime)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --bugs)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --builds)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --close-bugs)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --display-name)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --from-tag)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --notes)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --require-bugs)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --require-testcases)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --requirements)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --severity)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --stable-days)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --stable-karma)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --suggestion)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --unstable-karma)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --update-type)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__create__update__override)
            opts="-h --duration --notes --help <ALIAS>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --duration)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --notes)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__edit__override)
            opts="-h --duration --notes --help <NVR>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --duration)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --notes)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__edit__update)
            opts="-h --add-bugs --add-builds --autokarma --autotime --close-bugs --display-name --notes --remove-bugs --remove-builds --requirements --severity --stable-days --stable-karma --suggestion --unstable-karma --update-type --help <ALIAS>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --add-bugs)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --add-builds)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --autokarma)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --autotime)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --close-bugs)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --display-name)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --notes)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --remove-bugs)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --remove-builds)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --requirements)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --severity)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --stable-days)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --stable-karma)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --suggestion)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --unstable-karma)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --update-type)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__expire__override)
            opts="-h --help <NVR>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__query__overrides)
            opts="-f -h --builds --expired --format --releases --users --force --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --builds)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --expired)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --format)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --releases)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --users)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__query__updates)
            opts="-f -h --alias --bugs --builds --critpath --content-type --format --locked --modified-before --modified-since --packages --pushed --pushed-before --pushed-since --releases --request --severity --status --submitted-before --submitted-since --suggestion --type --users --force --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --alias)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --bugs)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --builds)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --critpath)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --content-type)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --format)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --locked)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --modified-before)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --modified-since)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --packages)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --pushed)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --pushed-before)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --pushed-since)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --releases)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --request)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --severity)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --status)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --submitted-before)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --submitted-since)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --suggestion)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --type)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --users)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__release__info)
            opts="-h --format --help <RELEASE>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --format)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__release__list)
            opts="-h --format --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --format)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__update__request)
            opts="-h --help <ALIAS> <REQUEST>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        bodhi__cli__waive__tests)
            opts="-h --tests --help <ALIAS> <COMMENT>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --tests)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

if [[ "${BASH_VERSINFO[0]}" -eq 4 && "${BASH_VERSINFO[1]}" -ge 4 || "${BASH_VERSINFO[0]}" -gt 4 ]]; then
    complete -F _bodhi-cli -o nosort -o bashdefault -o default bodhi-cli
else
    complete -F _bodhi-cli -o bashdefault -o default bodhi-cli
fi
